<?
/********************************
 IP-SYMCON Event Scripting
*********************************
File     : Titelauswahl.ips.php
Trigger  : OnChange: Base_Path
			  OnChange: Box_Artist_selected
			  OnChange: Box_Album_selected
			  OnChange: Box_Song_selected
Interval :
Author   : HJH
Project  : AudioPlayer
Date     : 11.04.09
********************************/

require_once "AudioPlayer_IDs.ips.php";

//$IPS_SENDER = "Variable";
//$IPS_VARIABLE = "Base_Path";

SetValueString(AudioPlayer_Caption, "HJH AudioPlayer V2");
$path = GetValueString(Base_Path);
$extensions = array(".mid", ".mp3", ".rmi", ".wav", ".wma", ".mpg");

switch ($IPS_SENDER)
{
	case "Variable":	// Events, die durch Variablen ausgelst wurden ***********
		switch ($IPS_VARIABLE)
		{
			case Base_Path:   // Basispfad hat sich gendert ----------------------
				$path = $IPS_VALUE;
				//echo $path. "\r\n";
				if (substr($path, -1, 1) != "\\") $path .= "\\";
				if (!file_exists($path))
				{
					SetValueBoolean(Base_Path_OK, false);
					return;
				}
				else
					SetValueBoolean(Base_Path_OK, true);
				if (GetValueString(Base_Path) !== $path)
					SetValueString(Base_Path, $path);
				$artistPath = $path;
				//echo $artistPath. "\r\n";
				SetValueString(Box_Artist, GetContent($artistPath));
				SetValueString(Box_Artist_selected, GetItem(Box_Artist, 0));
			//break;
			case Box_Artist_selected:  // Artist wurde ausgewhlt -----------------
				$artist = GetValueString(Box_Artist_selected);
				$albumPath = $path. $artist. "\\";
				//echo $albumPath. "\r\n";
				SetValueString(Box_Album, GetContent($albumPath));
				SetValueString(Box_Album_selected, GetItem(Box_Album, 0));
			//break;
			case Box_Album_selected:   // Album wurde ausgewhlt ------------------
				$artist = GetValueString(Box_Artist_selected);
				$album = GetValueString(Box_Album_selected);
				$songPath = $path. $artist. "\\". $album. "\\";
				//echo $songPath. "\r\n";
				SetValueString(Box_Song, GetContentExt($songPath, $extensions));
				SetValueString(Box_Song_selected, GetItem(Box_Song, 0));
			//break;
			case Box_Song_selected: // Song wurde ausgewhlt ----------------------
				$artist = GetValueString(Box_Artist_selected);
				$album = GetValueString(Box_Album_selected);
				$song = GetValueString(Box_Song_selected);
				$songPath = $path. $artist. "\\". $album. "\\". $song;
				//echo $songPath. "\r\n";
				SetValueString(Song_to_play, $songPath);
			break;
		}
	break;
	default:
	break;
}

function GetContent($path)
{
	$files = scandir($path);
	$fileStr = "";
	foreach ($files as $file)
		$fileStr .= $file. "|";
	$fileStr = substr($fileStr, 5);
	$fileStr = rtrim($fileStr, "|");
	$fileStr = ".|". $fileStr;
	//echo $fileStr. "\r\n";
	return $fileStr;
}

function GetContentExt($path, $extensions)
{
	$files = scandir($path);
	//print_r ($files);
	$fileStr = "";
	foreach ($files as $file)
		foreach ($extensions as $ext)
			if (strtolower(substr($file, -strlen($ext))) == $ext)
				$fileStr .= $file. "|";
	$fileStr = rtrim($fileStr, "|");
	//echo $fileStr. "\r\n";
	//print_r ($fileStr);
	return $fileStr;
}

function GetItem($str, $pos)
{
	$items = explode("|", GetValueString($str));
	//print_r ($items);
	$items[0] = ltrim($items[0], "\"");
	$c = count($items);
	$items[$c-1] = rtrim($items[$c-1], "\"");
	//print_r ($items[$pos]);
	return $items[$pos];
}
?>
