<?




$projectName = "AudioPlayerV2";
$applicationName = "AudioPlayer";
$MediaPlayerID = "{2999EBBB-5D36-407E-A52B-E9142A45F19C}";
$catID = IPS_CreateCategory();
IPS_SetName($catID, $projectName);
$aplID = IPS_CreateInstance($MediaPlayerID);
IPS_SetName($aplID, $applicationName);
IPS_SetParent($aplID, $catID);

$script1 = $applicationName;
$sc1ID = IPS_CreateScript(0);
IPS_SetScriptFile($sc1ID, $projectName. "\\". $script1. ".ips.php");
IPS_SetName($sc1ID, $script1);
IPS_SetParent($sc1ID, $catID);
$script2 = "Titelauswahl";
$sc2ID = IPS_CreateScript(0);
IPS_SetScriptFile($sc2ID, $projectName. "\\". $script2. ".ips.php");
IPS_SetName($sc2ID, $script2);
IPS_SetParent($sc2ID, $catID);

$fname = IPS_GetKernelDir(). "scripts\\". $projectName. "\\". $applicationName. "_IDs.ips.php";
$handle = fopen($fname, "w");
fwrite($handle, "<?\r\n");
$l = 'define ("'. $applicationName. '", '. $aplID. ');';
fwrite($handle, $l. "\r\n");

$varAudioPlayer  = array( array("AudioPlayer_Caption", 3),
								  array("Btn_Play_Status", 1),
								  array("Btn_Stop_Status", 1),
								  array("Slider", 1),
								  array("Slider_Target", 1),
								  array("Song_to_play", 3),
								  array("Volume_Target", 1));
foreach ($varAudioPlayer as $var)
{
	$ID = IPS_CreateVariable($var[1]);
	IPS_SetName($ID, $var[0]);
	IPS_SetParent($ID, $sc1ID);
	$l = 'define ("'. str_replace(" ", "_", $var[0]). '", '. $ID. ');';
	fwrite($handle, $l. "\r\n");
}

$varTitelauswahl = array( array("Base_Path", 3),
								  array("Base_Path_OK", 0),
								  array("Box_Artist", 3),
								  array("Box_Artist_selected", 3),
								  array("Box_Album", 3),
								  array("Box_Album_selected", 3),
								  array("Box_Song", 3),
								  array("Box_Song_selected", 3));
foreach ($varTitelauswahl as $var)
{
	$ID = IPS_CreateVariable($var[1]);
	IPS_SetName($ID, $var[0]);
	IPS_SetParent($ID, $sc2ID);
	$l = 'define ("'. str_replace(" ", "_", $var[0]). '", '. $ID. ');';
	fwrite($handle, $l. "\r\n");
}

$varMediaPlayer = array("Status",
								"Track Filename",
								"Track Length",
								"Track Position",
								"Volume");
foreach ($varMediaPlayer as $var)
{
	$ID = IPS_GetVariableIDByName($var, $aplID);
	$l = 'define ("'. str_replace(" ", "_", $var). '", '. $ID. ');';
	fwrite($handle, $l. "\r\n");
}
fwrite($handle, "?>");
fclose($handle);

$script3 = $applicationName. "_IDs";
$sc3ID = IPS_CreateScript(0);
IPS_SetScriptFile($sc3ID, $projectName. "\\". $script3. ".ips.php");
IPS_SetName($sc3ID, $script3);
IPS_SetParent($sc3ID, $catID);



$projectDir = IPS_GetKernelDir(). "scripts\\". $projectName. "\\". $projectName. "Media";
$mediaDirRelPath = "media\\". $projectName;
$mediaDir = IPS_GetKernelDir(). $mediaDirRelPath;
If (!file_exists($mediaDir)) mkdir($mediaDir);
IPS_Sleep(100);

$files = glob($mediaDir. "\\*.*");
foreach ($files as $file)
{
	$medium = $mediaDirRelPath. "\\". basename($file);
	$id = @IPS_GetMediaIDByFile($medium);
	if ($id)
	{
		echo "deregistriert und gelscht: ". $id. ": ---> ". $file. "\r\n";
		IPS_DeleteMedia($id, true);
	}
	else
	{
		echo "gelscht: keine ID: ---> ". $file. "\r\n";
	   unlink($file);
	}
	IPS_Sleep(100);
}

foreach (glob($projectDir. "\\*.*") as $file)
{
	echo "kopiert: ". $file. "\r\n";
	copy($file, $mediaDir. "\\". basename($file));
	IPS_Sleep(100);
}



$varID = IPS_GetVariableIDByName("Volume_Target", $sc1ID);
$evtID = IPS_CreateEvent(0);					// Trigger Event anlegen
IPS_SetEventTrigger($evtID, 1, $varID);	// OnChange
IPS_SetEventScript($evtID, $sc1ID);			// Skript zuordnen
IPS_SetEventActive($evtID, true);			// Trigger aktivieren

$varID = IPS_GetVariableIDByName("Track Position", $aplID);
$evtID = IPS_CreateEvent(0);					// Trigger Event anlegen
IPS_SetEventTrigger($evtID, 1, $varID);	// OnChange
IPS_SetEventScript($evtID, $sc1ID);			// Skript zuordnen
IPS_SetEventActive($evtID, true);			// Trigger aktivieren

$varID = IPS_GetVariableIDByName("Status", $aplID);
$evtID = IPS_CreateEvent(0);					// Trigger Event anlegen
IPS_SetEventTrigger($evtID, 1, $varID);	// OnChange
IPS_SetEventScript($evtID, $sc1ID);			// Skript zuordnen
IPS_SetEventActive($evtID, true);			// Trigger aktivieren

$varID = IPS_GetVariableIDByName("Base_Path", $sc2ID);
$evtID = IPS_CreateEvent(0);					// Trigger Event anlegen
IPS_SetEventTrigger($evtID, 1, $varID);	// OnChange
IPS_SetEventScript($evtID, $sc2ID);			// Skript zuordnen
IPS_SetEventActive($evtID, true);			// Trigger aktivieren

$varID = IPS_GetVariableIDByName("Box_Artist_selected", $sc2ID);
$evtID = IPS_CreateEvent(0);					// Trigger Event anlegen
IPS_SetEventTrigger($evtID, 1, $varID);	// OnChange
IPS_SetEventScript($evtID, $sc2ID);			// Skript zuordnen
IPS_SetEventActive($evtID, true);			// Trigger aktivieren

$varID = IPS_GetVariableIDByName("Box_Album_selected", $sc2ID);
$evtID = IPS_CreateEvent(0);					// Trigger Event anlegen
IPS_SetEventTrigger($evtID, 1, $varID);	// OnChange
IPS_SetEventScript($evtID, $sc2ID);			// Skript zuordnen
IPS_SetEventActive($evtID, true);			// Trigger aktivieren

$varID = IPS_GetVariableIDByName("Box_Song_selected", $sc2ID);
$evtID = IPS_CreateEvent(0);					// Trigger Event anlegen
IPS_SetEventTrigger($evtID, 1, $varID);	// OnChange
IPS_SetEventScript($evtID, $sc2ID);			// Skript zuordnen
IPS_SetEventActive($evtID, true);			// Trigger aktivieren



$formName = $projectName;
$formPath = IPS_GetKernelDir(). "scripts\\". $formName. "\\". $formName. ".formfile";
$targetPath = IPS_GetKernelDir(). "media\\". $formName. "\\". $formName. ".bin";
echo $formPath. "\r\n";

$catID = IPS_GetObjectIDByName($formName, 0);
$parentIDs = IPS_GetChildrenIDs($catID);

$form = file($formPath);
$n = 0;
foreach ($form as $line)
{
	$l = explode("Data.ScriptID = ", $line);
	if (count($l)>1)
	{
	   $name = rtrim($l[1]);
		$id = IPS_GetScriptIDByName($name, $catID);
		$newLine = $l[0]. "Data.ScriptID = ". $id. "\r\n";
		echo $newLine;
		$form[$n] = $newLine;
	}
	$n++;
}

$n = 0;
foreach ($form as $line)
{
	$l = explode("Data.VariableID = ", $line);
	if (count($l)>1)
	{
	   $name = rtrim($l[1]);
	   if ($name == "IP-Symcon")
	      $id = 0;
		else
		   foreach ($parentIDs as $parentID)
		   	if ($id = @IPS_GetVariableIDByName($name, $parentID)) break;
		$newLine = $l[0]. "Data.VariableID = ". $id. "\r\n";
		echo $newLine;
		$form[$n] = $newLine;
	}
	$n++;
}

$n = 0;
foreach ($form as $line)
{
	$l = explode("PictureID = ", $line);
	if (count($l)>1)
	{
	   $name = rtrim($l[1]);
   	$id = IPS_GetMediaIDByFile("media\\". $formName. "\\". $name);
		$newLine = $l[0]. "PictureID = ". $id. "\r\n";
		echo $newLine;
		$form[$n] = $newLine;
	}
	$n++;
}

foreach ($form as $line)
{
	echo $line;
}

file_put_contents($targetPath, $form);
?>